// config: norepeat noautolaunch
// Heightmap v0.6 - Max Smirnov. 2015
function Heightmap() 
{ 
	var imgPath = moi.filesystem.getOpenFileName( 'Open heightmap', 'Image files (JPEG, PNG, GIF, BMP)|*.jpg;*.jpeg;*.png;*.gif;*.bmp' );
	if ( !imgPath ) return false;
	var dlm = "\\";
	var filename = "heightmap_tmp_"+Math.round(Math.random()*100000000)+"_"+imgPath.substring(imgPath.lastIndexOf(dlm)+1);
	var tmpPath = moi.filesystem.getProcessDir()+'commands'+dlm+filename;
	moi.filesystem.copyFile(imgPath, tmpPath);
	
	var img = moi.ui.commandUI.document.createElement("img");
	img.src = filename;
	 
	var canvas = moi.ui.commandUI.document.createElement("canvas");
	moi.ui.commandUI.g_width = img.width;	canvas.width = img.width;
	moi.ui.commandUI.g_height = img.height;	canvas.height = img.height;
	
	if (img.width === 0) { moi.filesystem.deleteFile(tmpPath); return; }
	
	var context = canvas.getContext('2d');
	context.drawImage(img, 0, 0);
	
	try {	moi.ui.commandUI.g_imageData = context.getImageData(0, 0, canvas.width, canvas.height).data; } 
		catch (e) { moi.ui.alert("Unable to access image data!\n" + e); moi.filesystem.deleteFile(tmpPath); return; } 
	
	moi.filesystem.deleteFile(tmpPath);
	
	moi.ui.commandUI.init();
	while ( true )
	{
		moi.ui.commandDialog.waitForEvent();
		e  = moi.ui.commandDialog.event;
		if ( e == 'cancel' ) { moi.ui.commandUI.cancel(); return; }
		if ( e == 'done' ) { moi.ui.commandUI.done(); break; }
		if ( e == 'parameter' || e == 'parameterSlider' ) { }
		if ( e == 'type' ) { moi.ui.commandUI.buildBaseObjects(); moi.ui.commandUI.g_lastparameter = -1; }
	}
}
Heightmap();